// Copyright (c) 2007-2012  Michael Chapman
// http://ipaddresscontrollib.googlecode.com

// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:

// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.




using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
// using̍ŌɒǉQs
using System.Net;
using System.Net.Sockets;

namespace TcpSendMessage
{
    public partial class Form1 : Form
    {
        // ȉ̕ϐ錾ĂB
        TcpClient tcpclient;
        IPAddress ipAddress;
        int port;
        String message;
        string strErrMsg;
        NetworkStream stream;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        	// [Disconnect],[Clear],[Send]3̃{^񊈐ɂ
            btnDisconnect.Enabled = false;
            btnClear.Enabled = false;
            btnSend.Enabled = false;
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            // ipAddressRg[ipAddress擾
            ipAddress = new IPAddress(ipAddressControl.GetAddressBytes());

            // A|[g͂eLXg{bNXɓ͂΁AftHg̃|[g55555蓖Ă
            if (textBoxPort.Text.Length == 0)
                port = 55555;
            else // textBoxPortɓ͂ꂽl𐮐^ɕϊ
                port = Convert.ToInt32(textBoxPort.Text);

            //IPAhXƃ|[gԍgāATCPClientIuWFNg쐬
            tcpclient = new TcpClient(ipAddress.ToString(), port);

            // NetworkStreamgăf[^𑗐M
            stream = tcpclient.GetStream();

            //Nlabel3 not connectƕ\ĂB[Connect]{^Đڑ
            //ɓ삵Alabel3̕\ not connectconnectedɕύX
            label3.Text = "connected";

            //{^̕\ /񊈐
            // Enabledp[^truew肷ƃ{^ԂɂȂA
            // falseȂ񊈐̏ԂɂȂ艟ȂȂB
            btnSend.Enabled = true;
            btnConnect.Enabled = false;
            btnDisconnect.Enabled = true;
            btnClear.Enabled = true;
        }

        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            // {^̊/񊈐
            btnSend.Enabled = false;
            btnConnect.Enabled = true;
            btnDisconnect.Enabled = false;
            btnClear.Enabled = false;

            // \Pbg
            stream.Close();
            tcpclient.Close();
            // label3̕\ "not connected"ɕύX
            label3.Text = "not connected";
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            // TcpSocketڑԂȂ當𑗐M鏈s
            if (tcpclient.Connected == true)
            {
                // bZ[W͂TextBox當 messageϐɎ擾
                message = textBoxSendMsg.Text;

                Byte[] data = System.Text.Encoding.ASCII.GetBytes(message);

                // mbedɕ𑗐M 
                stream.Write(data, 0, data.Length);
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
        	// eLXgE{bNX̕\
            textBoxSendMsg.Clear();
            if (tcpclient.Connected == true)
            {
                // messageϐɃXy[X16̕
                message = "                ";

                Byte[] data = System.Text.Encoding.ASCII.GetBytes(message);

                // mbedɕ𑗐M 
                stream.Write(data, 0, data.Length);
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            if (tcpclient != null)
            {
                // \Pbg
                stream.Close();
                tcpclient.Close();
            }
            // vȌI
            Application.Exit();    
        }
    }
}
